/*
  this class controls the different decoders.
  Copyright (C) 1998  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */


#include <yafAmplifier/yafAmplifier.h>

YafAmplifier::YafAmplifier() {
  this->config=new AmplifierConfig();
}


YafAmplifier::~YafAmplifier() {
  delete config;
}


GenericStreamProducer* YafAmplifier::createDecoder(int decoderType) {
  int argn;
  YafProducer* decoder=new YafProducer();
  char** args=config->getExecutable(decoderType);
  GenericStreamProducer* player=new GenericStreamProducer();


  argn=0;
  while(1) {
    if ((*args)==NULL) {
      break;
    }
    decoder->addArgument((*args));
    argn++;
    args++;
  }
  if (argn == 0) {
    cout << "No executable for type : " << decoderType << "registered !"<<endl;
    return NULL;
  }

  // now we connect them:
  player->setProducer(decoder);
  decoder->startDecoder();

  return player;
}

  








    

  
